<?php

namespace Pmg\Includes;
use Pmg\Includes\Functions;

class Front
{

	private $filter;

	public function __construct() {
		$this->filter = new Filter;
		$this->filter->add_action( 'wp_enqueue_scripts', $this, 'puddinq_map_geo_scripts' );
		$this->filter->add_filter( 'the_content', 'Pmg\Includes\Functions', 'puddinq_map_geo_content_filter' );
		$this->filter->run();

	}

	public function puddinq_map_geo_scripts()
	{

		if (!is_admin() && is_singular( 'maps' )) {
			$pud_map_geo = Geo::pud_map_geo();
			/* leaflet style */
			wp_enqueue_style('ol-style', plugins_url('css/ol.css', PMGFILE), false, '');
			wp_enqueue_style('custom-style', plugins_url('css/custom.css', PMGFILE), false, '');
			/* leaflet script */
			wp_enqueue_script('ol-script', plugins_url('js/ol.js', PMGFILE), ['jquery'], 'v3.16.0', false);
			/* custom script to create the map */
			wp_enqueue_script('ol-custom-script', plugins_url('js/custom.js', PMGFILE), ['jquery', 'ol-script'], 'v0.0.2', true);
			/* get values with php from php-to-javascript-values.php and send them to js/custom-ol-map.js */
			wp_localize_script('ol-custom-script', 'pud_map_geo', $pud_map_geo);
		}
	}

}